package com.byteslounge;

import com.byteslounge.application.Application;
import com.byteslounge.db.connection.factory.ConnectionFactory;
import com.byteslounge.db.connection.factory.MySqlConnectionFactory;
import com.byteslounge.db.connection.factory.PostgreSqlConnectionFactory;

public class Main {

	public static void main(String[] args) {

		// We should fetch the database type from an
		// external resource (ex: configuration file).
		// In order to keep this example simple we will
		// use a private static method and an Enum
		DatabaseType databaseType = DatabaseType.MYSQL;
		ConnectionFactory connectionFactory = getConnectionFactory(databaseType);

		Application application = new Application(connectionFactory);
		application.start();
	}

	private static ConnectionFactory getConnectionFactory(
			DatabaseType databaseType) {
		switch (databaseType) {
		case MYSQL:
			return new MySqlConnectionFactory();
		default:
			return new PostgreSqlConnectionFactory();
		}
	}

	private enum DatabaseType {
		MYSQL, POSTGRE;
	}

}
